unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Psock, NMNNTP, QDialogs, FileCtrl;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    NMNNTP1: TNMNNTP;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    Edit1: TEdit;
    Panel1: TPanel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Label5: TLabel;
    ListBox1: TListBox;
    Button2: TButton;
    Label6: TLabel;
    ListBox2: TListBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label7: TLabel;
    Button6: TButton;
    CheckBox1: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label11: TLabel;
    Memo1: TMemo;
    Label12: TLabel;
    Memo2: TMemo;
    Label13: TLabel;
    Memo3: TMemo;
    Button7: TButton;
    Label15: TLabel;
    Panel2: TPanel;
    Label14: TLabel;
    Label16: TLabel;
    Edit7: TEdit;
    Label17: TLabel;
    Edit8: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Memo4: TMemo;
    Label20: TLabel;
    Button8: TButton;
    Button9: TButton;
    ListBox3: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure NMNNTP1HeaderList(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure NMNNTP1Abort(Sender: TObject);
    procedure NMNNTP1Article(Sender: TObject);
    procedure NMNNTP1AuthenticationFailed(Sender: TObject);
    procedure NMNNTP1AuthenticationNeeded(var Handled: Boolean);
    procedure NMNNTP1Body(Sender: TObject);
    procedure NMNNTP1Header(Sender: TObject);
    procedure NMNNTP1Connect(Sender: TObject);
    procedure NMNNTP1Disconnect(Sender: TObject);
    procedure NMNNTP1GroupSelectRequired(var Handled: Boolean);
    procedure NMNNTP1InvalidArticle(Sender: TObject);
    procedure NMNNTP1Posted(Sender: TObject);
    procedure NMNNTP1PostFailed(Sender: TComponent; Errno: Word;
      Errmsg: String);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if  NMNNTP1.Connected  then NMNNTP1.Disconnect
  else
    begin
      if Edit1.Text <> '' then
      begin
         NMNNTP1.UserID := Edit2.Text;
         NMNNTP1.Password := Edit3.Text;
      end;
      NMNNTP1.Host := Edit1.Text;
      NMNNTP1.Connect;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
// 
var
  S: String;
  I: Integer;
begin
  if InputQuery(' ', '  ', S) then
  begin
     I := StrToIntDef (S, -1);
     if I <> -1 then NMNNTP1.GetArticle(I);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
//  
var
  S: String;
  I: Integer;
begin
  if InputQuery('  ', '  ', S) then
  begin
    I := StrToIntDef(S, -1);
    if I <> -1 then NMNNTP1.GetArticleHeader(I);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
// 
var
  S: String;
  I: Integer;
begin
  if InputQuery('  ', '  ', S) then
  begin
       I := StrToIntDef(S, -1);
       if I <> -1 then NMNNTP1.GetArticleBody(I);
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then
  begin
    ListBox2.Clear;
    NMNNTP1.SetGroup(ListBox1.Items[ListBox1.ItemIndex]);
    Label14.Caption := '     : '+NMNNTP1.SelectedGroup;
  end;
  if NMNNTP1.Posting then
     Label15.Caption := '     '
  else
     Label15.Caption := '     ';
end;

procedure TForm1.Button6Click(Sender: TObject);
// 
var
  S: String;
begin
  if SelectDirectory (S, [sdAllowCreate, sdPerformCreate, sdPrompt], 0) then
  begin
    Label7.Caption:='    :'+S;
    NMNNTP1.AttachFilePath := S;
  end;

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
//   
begin
  if CheckBox1.Checked then
        NMNNTP1.ParseAttachments := true
  else
        NMNNTP1.ParseAttachments := false;
end;

procedure TForm1.NMNNTP1HeaderList(Sender: TObject);
begin
  ListBox2.Items.Add('['+IntToStr(NMNNTP1.HeaderRecord.PrArticleID)+'] Subject: '+NMNNTP1.HeaderRecord.PrSubject);
end;

procedure TForm1.Button2Click(Sender: TObject);
//   
begin
  NMNNTP1.GetArticleList (true, 0);
  Label6.Caption := '   '+NMNNTP1.SelectedGroup+'   '+IntToStr(NMNNTP1.LoMessage)+' no  '+IntToStr(NMNNTP1.HiMessage);
end;

procedure TForm1.Button7Click(Sender: TObject);
// 
begin
  NMNNTP1.Abort;
end;

procedure TForm1.Button9Click(Sender: TObject);
//
begin
  NMNNTP1.PostAttachments.Text := ListBox3.Items.Text;
  NMNNTP1.PostBody.Text := Memo4.Text;
  with NMNNTP1.PostRecord do
  begin
    PrFromAddress := Edit7.Text;
    PrReplyTo := Edit7.Text;
    PrSubject := Edit8.Text;
    PrNewsGroups := NMNNTP1.SelectedGroup;
  end;
  NMNNTP1.PostHeader.Values['Organization' ]:= '  Delphi';
  NMNNTP1.PostArticle;
end;

procedure TForm1.NMNNTP1Abort(Sender: TObject);
begin
   StatusBar1.SimpleText := '  ';
end;

procedure TForm1.NMNNTP1Article(Sender: TObject);
begin
  Memo2.Text:=NMNNTP1.Body.Text;
  Memo1.Text:=NMNNTP1.Header.Text;
  Memo3.Text:=NMNNTP1.Attachments.Text;
  Edit4.Text:=NMNNTP1.HeaderRecord.PrFromAddress;
  Edit5.Text:=NMNNTP1.HeaderRecord.PrSubject;
  Edit6.Text:=NMNNTP1.HeaderRecord.PrTimeDate;
  Label11.Caption := '  '+IntToStr(NMNNTP1.CurrentArticle);
  Label12.Caption := '  '+IntToStr(NMNNTP1.CurrentArticle);
end;

procedure TForm1.NMNNTP1AuthenticationFailed(Sender: TObject);
begin
  ShowMessage(' ');
end;

procedure TForm1.NMNNTP1AuthenticationNeeded(var Handled: Boolean);
var AnID,
    APass: String;
begin
  if NMNNTP1.UserID = '' then
  begin
    if InputQuery(' ','  ', AnID) then
    begin
      NMNNTP1.UserID := AnID;
      Handled := true;
    end;
  end;
  if NMNNTP1.Password = '' then
  begin
      if InputQuery(' ', ' ', APass) then
      begin
        NMNNTP1.Password := APass;
        Handled := true;
      end;
  end;
end;

procedure TForm1.NMNNTP1Body(Sender: TObject);
begin
  Memo2.Text := NMNNTP1.Body.Text;
  Memo3.Text := NMNNTP1.Attachments.Text;
  Label12.Caption := '  '+IntToStr(NMNNTP1.CurrentArticle);
end;

procedure TForm1.NMNNTP1Header(Sender: TObject);
begin
  Memo1.Text := NMNNTP1.Header.Text;
  Edit4.Text := NMNNTP1.HeaderRecord.PrFromAddress;
  Edit5.Text := NMNNTP1.HeaderRecord.PrSubject;
  Edit6.Text := NMNNTP1.HeaderRecord.PrTimeDate;
  Label11.Caption := '  '+IntToStr(NMNNTP1.CurrentArticle);
end;

procedure TForm1.NMNNTP1Connect(Sender: TObject);
var
  I: Integer;
begin
  StatusBar1.SimpleText := '';
  ShowMessage('    . ');
  NMNNTP1.GetGroupList;
  for I := 0 to (NMNNTP1.GroupList.Count - 1) do
    ListBox1.Items.Add(NthWord(NMNNTP1.GroupList[I], ' ', 1)); 
end;

procedure TForm1.NMNNTP1Disconnect(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
end;

procedure TForm1.NMNNTP1GroupSelectRequired(var Handled: Boolean);
var
  S: String;
begin
  if InputQuery('He   ', '  : ', S) then
  begin
   NMNNTP1.SetGroup (S);
   Handled := true;
  end;
end;

procedure TForm1.NMNNTP1InvalidArticle(Sender: TObject);
begin
  ShowMessage('   ');
end;

procedure TForm1.NMNNTP1Posted(Sender: TObject);
begin
  StatusBar1.SimpleText := '  ';
end;

procedure TForm1.NMNNTP1PostFailed(Sender: TComponent; Errno: Word;
  Errmsg: String);
begin
  ShowMessage('   : '+Errmsg+'   '+IntToStr (Errno));
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Label7.Caption := '    : ' +
   NMNNTP1.AttachFilePath;
  if NMNNTP1.ParseAttachments = true then CheckBox1.Checked := true
  else CheckBox1.Checked := false;
end;

end.
